;**************************************************************
;    Color (32 Bit)
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************
;GERMAN:
;  Die eigentliche Arbeit ist Martin Guttmann (STARGTE aus http://www.pure-board.de/)
;  zu verdanken. Ich habe lediglich die uerliche Form
;  bearbeitet.
;  Siehe auch: http://guttgame.q-soft.ch/UnionBytes/Codes/Color.pbi
;
;  IN BEARBEITUNG!



CompilerIf Defined(Color_PBI, #PB_Constant) = #False
#Color_PBI = #True



;******************************************
; Includes
;******************************************

IncludeFile #PB_Compiler_FilePath + "Standard.pbi"

;GERMAN:
;  Die Funktion "Lim" fr das eingrenzen von Frabkanlen
;  wird bentigt.
IncludeFile #PB_Compiler_FilePath + "Math.pbi"



;******************************************
; Functions
;******************************************

CompilerIf #PB_Compiler_Debugger
  Procedure.i DisplayColor(Color.i)
    ;  Author: Josef Sniatecki
    ;
    ;GERMAN:
    ;  Funktion um eine Frabe handlich anzeigen zu knnen:
    ;  TODO: Das Fenster soll den Fokus nur fr sich behalten (wie ein MessageRequester).
    
    Protected Window.i, Event.i, Image.i, ImageGadget.i
    
    Image = CreateImage(#PB_Any, 150, 150)
    StartDrawing(ImageOutput(Image))
      Box(0, 0, 150, 150, Color)
    StopDrawing()
    
    Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 150, 150, Hex(Color, #PB_Integer), #PB_Window_SystemMenu|#PB_Window_TitleBar|#PB_Window_ScreenCentered)
      ImageGadget = ImageGadget(#PB_Any, 0, 0, 150, 150, ImageID(Image))
    
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndProcedure
CompilerEndIf
  

Procedure.f ColorDistance(Color1.i, Color2.i)
  ;  Author: Josef Sniatecki
  ;
  ;GERMAN:
  ;  Gibt den Unterschied (normiert) zweier Farben zurck.
  ;  "0" steht fr gleiche Frabe (kein Unterschied) und "1.0" fr
  ;  den maximalen Unterschied (komplementre Fraben).
  
  Protected Red.i, Green.i, Blue.i
  
  Red   = Red(Color1)   - Red(Color2)
  Green = Green(Color1) - Green(Color2)
  Blue  = Blue(Color1)  - Blue(Color2)
  
  ProcedureReturn Sqr(Red*Red + Green*Green + Blue*Blue) / 441.67295593006370984
EndProcedure

Procedure ColorMix(Color1.i, Color2.i, Factor.f = 0, Flags = 0)
  ;  Author: Josef Sniatecki
  ;
  ;ENGLISH:
  ;  MixFactor = -1.0  -> 100% Color1 ,   0% Color2
  ;  MixFactor =  0.0  ->  50% Color1 ,  50% Color2
  ;  MixFactor =  1.0  ->   0% Color1 , 100% Color2
  
  Protected R.i, G.i, B.i, P.f, P1.f, P2.f
  
  If Flags
    If MixFactor < 0
      P = (MixFactor + 1)
      R = Lim( Red(Color1)   + Red(Color2)*P  , 0, 255)
      G = Lim( Green(Color1) + Green(Color2)*P, 0, 255)
      B = Lim( Blue(Color1)  + Blue(Color2)*P , 0, 255)
    Else
      P = (1-MixFactor)
      R = Lim( Red(Color2)   + Red(Color1)*P  , 0, 255)
      G = Lim( Green(Color2) + Green(Color1)*P, 0, 255)
      B = Lim( Blue(Color2)  + Blue(Color1)*P , 0, 255)
    EndIf
    ProcedureReturn RGB(R, G, B)
  Else
    P2 = (MixFactor + 1) / 2
    P1 = 1 - P2 
    R = Red(Color1)*P1   + Red(Color2)*P2
    G = Green(Color1)*P1 + Green(Color2)*P2
    B = Blue(Color1)*P1  + Blue(Color2)*P2
    ProcedureReturn RGB(R, G, B)
  EndIf
EndProcedure



; ; Verndert die Helligkeit einer Farbe
; ;  Brightness = -1.0  ->  dunkel (schwarz)
; ;  Brightness = 0.0  ->  normal
; ;  Brightness = +1.0  ->  hell (wei)
; Procedure ColorBrightness(Color, Brightness.f, Flags=0)
;  Protected R, G, B, RGB
;  Select Flags
;   Case 0
;    R = Real255(   Red(Color) + Brightness*255 )
;    G = Real255( Green(Color) + Brightness*255 )
;    B = Real255(  Blue(Color) + Brightness*255 )
;    ProcedureReturn RGB(R,G,B)
;   Case 1
;    If Brightness < 0
;     R = Real255(   Red(Color) * (1+Brightness) )
;     G = Real255( Green(Color) * (1+Brightness) )
;     B = Real255(  Blue(Color) * (1+Brightness) )
;    Else
;     R = Brightness*255 +   Red(Color) * (1-Brightness)
;     G = Brightness*255 + Green(Color) * (1-Brightness)
;     B = Brightness*255 +  Blue(Color) * (1-Brightness)
;    EndIf
;    ProcedureReturn RGB(R,G,B)
;   Case 2
;    RGB = ColorMix(ColorBrightness(Color, Brightness, 0), ColorBrightness(Color, Brightness, 1))
;    ProcedureReturn RGB
;  EndSelect
; EndProcedure
; 
; 
; 
; ; Verndert die Intensitt einer Farbe
; ;  Intensity = 0.0  ->  keine Intensitt (schwarz)
; ;  Intensity = 1.0  ->  normale Intensitt
; ;  Intensity = 2.0  ->  hhere Intensitt
; Procedure ColorIntensity(Color, Intensity.f)
;  Protected R, G, B
;  R = Real255(   Red(Color) * Intensity )
;  G = Real255( Green(Color) * Intensity )
;  B = Real255(  Blue(Color) * Intensity )
;  ProcedureReturn RGB(R,G,B)
; EndProcedure
; 
; 
; 
; ; Verndert den Kontrast einer Farbe
; ;  Contrast = -1.0  ->  kein Kotrast (grau)
; ;  Contrast = 0.0  ->  normaler Kotrast
; ;  Contrast = +1.0  ->  hoher Kontast
; Procedure ColorContrast(Color, Contrast.f)
;  Protected R, G, B
;  R = Real255(   Red(Color) + (  Red(Color)-128) * Contrast )
;  G = Real255( Green(Color) + (Green(Color)-128) * Contrast )
;  B = Real255(  Blue(Color) + ( Blue(Color)-128) * Contrast )
;  ProcedureReturn RGB(R,G,B)
; EndProcedure
; 
; 
; 
; ; Verndert den Gamma-Wert einer Farbe
; ;  Gamma < 1.0  ->     dunkeler
; ;  Gamma = 1.0  ->     keine nderung
; ;  Gamma > 1.0  ->     heller
; Procedure ColorGamma(Color, Gamma.f)
;  Protected R, G, B
;  R = Real255( Pow(   Red(Color)/255 , 1/Gamma ) * 255 )
;  G = Real255( Pow( Green(Color)/255 , 1/Gamma ) * 255 )
;  B = Real255( Pow(  Blue(Color)/255 , 1/Gamma ) * 255 )
;  ProcedureReturn RGB(R,G,B)
; EndProcedure
; 
; 
; 
; ; Gibt die Graufarbe einer Farbe zurck
; ;  Intensity = 0.0  ->  Farbig
; ;  Intensity = 1.0  ->  Grau
; ;  GrayColor :   Graufarbe die erreich werden soll (RGB-Farbe)      
; Procedure ColorGray(Color, Intensity.f, GrayColor=$FFFFFF)
;  Protected R, G, B, Gray.f
;  #GrayColorFactorRed   = 0.299 
;  #GrayColorFactorGreen = 0.587
;  #GrayColorFactorBlue  = 0.114 
;  Gray = #GrayColorFactorRed*Red(Color) + #GrayColorFactorGreen*Green(Color) + #GrayColorFactorBlue*Blue(Color)
;  R =   Red(GrayColor) * Gray/255*Intensity +   Red(Color) * (1-Intensity)
;  G = Green(GrayColor) * Gray/255*Intensity + Green(Color) * (1-Intensity)
;  B =  Blue(GrayColor) * Gray/255*Intensity +  Blue(Color) * (1-Intensity)
;  ProcedureReturn RGB(R,G,B)
; EndProcedure
; 
; 
; 
; ; Invertierung einer Farbe
; ;  Factor = 0.0  ->     normal Farben
; ;  Factor = 1.0  ->     inverse Farben
; Procedure ColorInverse(Color, Factor.f=1)
;  Protected R, G, B
;  If Factor = 1
;   ProcedureReturn Color ! $FFFFFF
;  Else
;   ProcedureReturn ColorMix(Color, Color ! $FFFFFF, Factor*2-1)
;  EndIf
; EndProcedure




CompilerEndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 83
; FirstLine = 75
; Folding = -
; EnableXP