;**************************************************************
;    Event queue
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(Event_PBI, #PB_Constant) = #False
#Event_PBI = #True



;******************************************
; Includes
;******************************************

IncludeFile #PB_Compiler_FilePath + "Standard.pbi"
IncludeFile #PB_Compiler_FilePath + "Queue.pbi"



;******************************************
; Section
;******************************************

Structure Event
  *Function
  TriggerTime.i
  *Parameter
EndStructure



;******************************************
; Variables
;******************************************

Global *EventQueue.Queue



;******************************************
; Functions
;******************************************

Declare.i FreeEvent(*Event.Event)



Procedure.i InitEvent()
  *EventQueue = CreateQueue(@FreeEvent())
EndProcedure
Procedure.i AddEvent(*Function, TriggerTime.i, *Parameter = 0)
  Protected *Event.Event
  
  *Event = _New(Event)
  AppendQueueItem(*EventQueue, *Event)
  *Event\Function    = *Function
  *Event\TriggerTime = TriggerTime
  *Event\Parameter   = *Parameter
  ProcedureReturn *Event
EndProcedure
Procedure.i ExamineEvents()
  Protected *Item.QueueItem,*Event.Event
  
  *Item = *EventQueue\First
  While *Item
    *Event = *Item\Memory
    If *Event\TriggerTime <= 0
      _Call(*Event\Function, *Event\Parameter)
      If *Event\Parameter
        FreeMemory(*Event\Parameter)
      EndIf
      *Item = FreeQueueItem(*EventQueue, *Item)
      Continue
    Else
      *Event\TriggerTime - 1
    EndIf
    _Move(*Item, N)
  Wend
EndProcedure
Procedure.i ExamineOneEvent()
  Protected *Event.Event
  
  If *EventQueue\First
    *Event = *EventQueue\First\Memory
    If *Event\TriggerTime <= 0
      _Call(*Event\Function, *Event\Parameter)
      If *Event\Parameter
        FreeMemory(*Event\Parameter)
      EndIf
      FreeFirstQueueItem(*EventQueue)
      ProcedureReturn #True
    Else
      *Event\TriggerTime - 1
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure
Procedure.i FreeEvent(*Event.Event)
  If *Event\Parameter
    FreeMemory(*Event\Parameter)
  EndIf
  FreeMemory(*Event)
  ProcedureReturn #True
EndProcedure



CompilerEndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = --
; EnableXP