;**************************************************************
;    Hyperbolic functions
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(HyperbolicFunctions_PBI, #PB_Constant) = #False
#HyperbolicFunctions_PBI = #True



;******************************************
; Includes
;******************************************

CompilerIf Defined(E, #PB_Constant) = #False
  #E = 2.7182818284590452354
CompilerEndIf



;******************************************
; Functions
;******************************************

Procedure.d SinH(X.d)
  ProcedureReturn (Pow(#E, X) - Pow(#E, -X))/2
EndProcedure
Procedure.d CosH(X.d)
  ProcedureReturn (Pow(#E, X) + Pow(#E, X))/2
EndProcedure
Procedure.d TanH(X.d) ;SinH(X)/CosH(X)
  Protected Z.f
  
  Z = Pow(#E, 2*x)
  ProcedureReturn (Z + 1)/(Z - 1)
EndProcedure
Procedure.d CotH(X.d) ;CosH(X)/SinH(X)
  Protected Z.f
  
  Z = Pow(#E, 2*x)
  ProcedureReturn (Z - 1)/(Z + 1)
EndProcedure



CompilerEndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableXP