;**************************************************************
;    Keyboard
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(Keyboard_PBI, #PB_Constant) = #False
#Keyboard_PBI = #True



;******************************************
; Functions
;******************************************

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    ;DEUTSCH:
    ;  Alle Funktionen verwenden die VK-Key-Codes. Siehe
    ;  dazu unter "http://msdn.microsoft.com/en-us/library/ms927178.aspx"
    ;  PB hat alle Konstanten unter "#VK_..." definiert.
    
    Procedure.i IsCapsLock()
      ProcedureReturn GetKeyState_(#VK_CAPITAL)
    EndProcedure
    Procedure.i IsNumLock()
      ProcedureReturn GetKeyState_(#VK_NUMLOCK)
    EndProcedure
    Procedure.i IsScrollLock()
      ProcedureReturn GetKeyState_(#VK_SCROLL)
    EndProcedure
    
    Procedure.i KeyPressedDown(Key.i)
      If GetAsyncKeyState_(Key) = -32767
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    EndProcedure
    Procedure.i IsKeyPressing(Key.i)
      If GetAsyncKeyState_(Key)
        ProcedureReturn #True
      Else
        ProcedureReturn #False
      EndIf
    EndProcedure
    Procedure.s KeyName(Key.i)
      Protected Name.s
      
      Name = Space(255)
      GetKeyNameText_(MapVirtualKey_(Key.i, 0) * $10000, @Name, 255)
      ProcedureReturn Name
    EndProcedure
    
    Procedure.i PressKey(Key.i)
      keybd_event_(Key, 0, #KEYEVENTF_EXTENDEDKEY, 0)
      keybd_event_(Key, 0, #KEYEVENTF_EXTENDEDKEY|#KEYEVENTF_KEYUP, 0)
    EndProcedure
    Procedure.i PressKeyDown(Key.i)
      keybd_event_(Key, 0, #KEYEVENTF_EXTENDEDKEY, 0)
    EndProcedure
    Procedure.i ReleaseKey(Key.i)
      keybd_event_(Key, 0, #KEYEVENTF_EXTENDEDKEY|#KEYEVENTF_KEYUP, 0)
    EndProcedure
  CompilerDefault
    CompilerError "Only supported unter Windows."
CompilerEndSelect



CompilerEndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 74
; FirstLine = 41
; Folding = --
; EnableXP