;**************************************************************
;     Screen
;
;  Authors: Josef Sniatecki
;
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(Screen_PBI, #PB_Constant) = #False
#Screen_PBI = #True



;******************************************
; Includes
;******************************************

IncludeFile #PB_Compiler_FilePath + "Standard.pbi"



;******************************************
; Functions
;******************************************

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    Procedure.i SetScreenSettings(Width.i ,Height.i, BitsPerPel.i ,Frequency.i ,TestMode.i = #Disabled)
      ;  Author: Josef Sniatecki
      
      Protected DevMode.DEVMODE
      
      DevMode\dmSize             = _Sz(DEVMODE)
      DevMode\dmFields           = #DM_BITSPERPEL | #DM_PELSWIDTH | #DM_PELSHEIGHT | #DM_DISPLAYFREQUENCY
      DevMode\dmBitsPerPel       = BitsPerPel
      DevMode\dmPelsWidth        = Width
      DevMode\dmPelsHeight       = Height
      DevMode\dmDisplayFrequency = Frequency
      
      ProcedureReturn ChangeDisplaySettings_(@DevMode, TestMode)
    EndProcedure
    Procedure.i GetScreenSettings(*Width.Integer, *Height.Integer, *BitsPerPel.Integer, *Frequency.Integer)
      ;  Author: Josef Sniatecki
      
      Protected DevMode.DEVMODE
      
      EnumDisplaySettings_(0, #ENUM_CURRENT_SETTINGS, @DevMode)
      *Width\I      = DevMode\dmPelsWidth
      *Height\I     = DevMode\dmPelsHeight
      *BitsPerPel\I = DevMode\dmBitsPerPel
      *Frequency\I  = DevMode\dmDisplayFrequency
    EndProcedure
CompilerEndSelect



CompilerEndIf
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 43
; FirstLine = 20
; Folding = -
; EnableXP