;**************************************************************
;    System
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(System_PBI, #PB_Constant) = #False
#System_PBI = #True



;******************************************
; Functions
;******************************************

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    Procedure.s ReadRegKey(OpenKey.i, SubKey.s, ValueName.s)
      ;  Author: Josef Sniatecki
      
      Protected Key.i = 0, Value.s = Space(255), Size.i = 255
      
      If RegOpenKeyEx_(OpenKey, SubKey, 0, #KEY_READ, @Key)
        Value = "ERROR"
      Else
        If RegQueryValueEx_(Key, ValueName, 0, 0, @Value, @Size)
          Value = "ERROR"
        Else
          Value = Left(Value, Size - 1)
        EndIf
        RegCloseKey_(Key)
      EndIf
      
      ProcedureReturn Value
    EndProcedure
    
    Procedure.s GetSystemPath(Type.i) ;Return a specified system path of the current user.
      ;  Author: Josef Sniatecki
      ;
      ;Constants to find at http://msdn.microsoft.com/en-us/library/bb762494%28VS.85%29.aspx
      
      Protected *ItemID.ITEMIDLIST
      Protected Path.s
      
      *ItemID = #Null
      If SHGetSpecialFolderLocation_ (0, Type, @*ItemID) = #NOERROR
        Path = Space(#MAX_PATH)
        If SHGetPathFromIDList_(*ItemID, @Path)
          ProcedureReturn Path + "\"
        EndIf
      EndIf
      ProcedureReturn ""
    EndProcedure
    Procedure.s GetStandardBrowser()
      ;  Author: Josef Sniatecki
      ;  Thanks to PureLust (user at "www.pure-board.de")!
      
      Protected HTMLClass.s, HTMLCommand.s
      
      If OSVersion() => #PB_OS_Windows_Vista
        HTMLClass   = ReadRegKey(#HKEY_CURRENT_USER, "Software\Microsoft\Windows\Shell\Associations\UrlAssociations\http\UserChoice", "ProgID")
        HTMLCommand = ReadRegKey(#HKEY_LOCAL_MACHINE, "SOFTWARE\Classes\" + HTMLClass + "\shell\open\command", "")
      Else
        HTMLClass   = ReadRegKey(#HKEY_CLASSES_ROOT, ".html", "")
        HTMLCommand = ReadRegKey(#HKEY_CLASSES_ROOT, HTMLClass + "\shell\open\command", "")
      EndIf
      
      ProcedureReturn GetPathPart(HTMLCommand) + GetFilePart(HTMLCommand)
    EndProcedure
CompilerEndSelect



CompilerEndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 56
; FirstLine = 42
; Folding = -
; EnableXP