;**************************************************************
;    Vector (2D)
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(Vector2D_PBI, #PB_Constant) = #False
#Vector2D_PBI = #True



;******************************************
; Includes
;******************************************

IncludeFile #PB_Compiler_FilePath + "Standard.pbi"



;******************************************
; Constants
;******************************************

CompilerIf Defined(V2_Max, #PB_Constant) = #False
  #V2_Max = 80
CompilerEndIf



;******************************************
; Functions
;******************************************

Procedure.i V2(X.f, Y.f)
  Static Dim TempV2.V2(#V2_Max), Index.i
  Protected *V2.V2
  
  *V2   = @TempV2(Index)
  *V2\X = X
  *V2\Y = Y
  
  If Index = #V2_Max
    Index = 0
  Else
    Index + 1
  EndIf
  
  ProcedureReturn *V2
EndProcedure
Procedure.i CreateV2(X.f, Y.f)
  Protected *V2.V2
  
  *V2   = _New(V2)
  *V2\X = X
  *V2\Y = Y
  
  ProcedureReturn *V2
EndProcedure

Procedure.i SetV2(*This.V2, *Other.V2)
   *This\X = *Other\X
   *This\Y = *Other\Y
   ProcedureReturn *This
EndProcedure
Procedure.i AddV2(*A.V2, *B.V2)
  ProcedureReturn V2(*A\X + *B\X, *A\Y + *B\Y)
EndProcedure
Procedure.i SubV2(*A.V2, *B.V2)
  ProcedureReturn V2(*A\X - *B\X, *A\Y - *B\Y)
EndProcedure
Procedure.i MulV2(*A.V2, *B.V2)
  ProcedureReturn V2(*A\X * *B\X, *A\Y * *B\Y)
EndProcedure
Procedure.i DivV2(*A.V2, *B.V2)
  ProcedureReturn V2(*A\X / *B\X, *A\Y / *B\Y)
EndProcedure

Procedure.f V2Len(*This.V2)
  ProcedureReturn Sqr(*This\X * *This\X + *This\Y + *This\Y)
EndProcedure
Procedure.f V2Angle(*This.V2)
  ProcedureReturn ATan(*This\Y / *This\X)
EndProcedure

Procedure.s StrV2(*This.V2)
  ProcedureReturn "(" + StrFN(*This\X) + ", " + StrFN(*This\Y) + ")"
EndProcedure



CompilerEndIf
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 5
; Folding = --
; EnableXP