;**************************************************************
;    Window
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(Window_PBI, #PB_Constant) = #False
#Window_PBI = #True



;******************************************
; Includes
;******************************************

IncludeFile #PB_Compiler_FilePath + "Standard.pbi"



;******************************************
; Constants
;******************************************

; Meistverwendete Fensterattribute:
#PB_Window_Standard           = #PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_SystemMenu
#PB_Window_StandardResizeable = #PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_SizeGadget|#PB_Window_TitleBar|#PB_Window_SystemMenu

; Weitere Events fr Fenster-Anwendungen:
#PB_Event_Character   = #WM_CHAR            ;Zeichen eingegeben (Char.c = wParam)
#PB_Event_KeyDown     = #WM_KEYDOWN         ;Taste wird gedrckt (VKKey.i = wParam)
#PB_Event_KeyUp       = #WM_KEYUP           ;Taste wurde losgelassen
#PB_Event_Shutdown    = #WM_QUERYENDSESSION ;Vor dem Runterfahren (Rckgabewert: True = Runterfahren erlauben, False = Runterfahren stoppen)
#PB_Event_Help        = #WM_HELP

#PB_Event_MouseWheel            = #WM_MOUSEWHEEL    ;Maus-Rad wurde gescrollt
  #PB_MouseWheel_Delta          = 120               ;Ticks  = _HighWord(wParam) / #PB_MouseWheel_Delta
#PB_Event_MouseMove             = #WM_MOUSEMOVE     ;Die Maus wurde bewegt
#PB_Event_LeftMouseButtonDown   = #WM_LBUTTONDOWN
#PB_Event_RightMouseButtonDown  = #WM_RBUTTONDOWN
#PB_Event_MiddleMouseButtonDown = #WM_MBUTTONDOWN
#PB_Event_LeftMouseButtonUp     = #WM_LBUTTONUP
#PB_Event_RightMouseButtonUp    = #WM_RBUTTONUP
#PB_Event_MiddleMouseButtonUp   = #WM_MBUTTONUP
#PB_Event_LeftDoubleClick       = #WM_LBUTTONDBLCLK
#PB_Event_RightDoubleClick      = #WM_RBUTTONDBLCLK
#PB_Event_MiddleDoubleClick     = #WM_MBUTTONDBLCLK

; Konstanten fr Tasten, die whren eines Events gedrckt sind:
#PB_KeyDown_Control           = #MK_CONTROL
#PB_KeyDown_Shift             = #MK_SHIFT
#PB_KeyDown_LeftMouseButton   = #MK_LBUTTON
#PB_KeyDown_RightMouseButton  = #MK_RBUTTON
#PB_KeyDown_MiddleMouseButton = #MK_MBUTTON



;******************************************
; Functions
;******************************************

CompilerIf #PB_Compiler_OS
  Procedure.i EnableWindowHelp(Window.i)
    ;Aktiviert das Help-Button in der Titelleiste.
    
    SetWindowLongPtr_(WindowID(Window), #GWL_EXSTYLE, #WS_EX_CONTEXTHELP)
  EndProcedure
  Procedure.i GetHelpGadget()
    ;Wird "#PB_Event_Help" gesendet, so kann durch diese
    ;Funktion das gewhlte Gadget ermittelt werden.
    
    Protected *Info.HELPINFO
    
    *Info = EventlParam()
    ProcedureReturn *Info\iCtrlId
  EndProcedure
  
  Procedure.i SetMenuItemImageOnRight(Menu.i, MenuItemID.i, Image.i)
    ;Fgt ein Image in ein Men-Item hinzu. Dieses wird nicht als
    ;Text verwendet, sondern rechts neben den Text gesetzt.
    
    Protected MenuItemInfo.MENUITEMINFO
    
    MenuItemInfo\cbSize     = _Sz(MENUITEMINFO)
    MenuItemInfo\fMask      = #MIIM_TYPE
    MenuItemInfo\fType      = #MFT_BITMAP
    MenuItemInfo\dwTypeData = ImageID(Image)
    SetMenuItemInfo_(MenuID(Menu), 1, 0, @MenuItemInfo)
  EndProcedure
CompilerEndIf



CompilerEndIf
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableXP