;**************************************************************
;    Window screenshot
;  
;  Authors: Josef Sniatecki
;  Copyright (c) 2010 Josef Sniatecki
;**************************************************************



CompilerIf Defined(WindowScreenshot_PBI, #PB_Constant) = #False
#WindowScreenshot_PBI = #True



CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    Procedure SaveWindowScreenshot(Window.i, ImagePath.s)
      ;  Author: Josef Sniatecki
      ;  Thanks to Kai (user at http://www.pure-board.de/)!
      
      Protected DesktopDC.i, DC.i
      Protected Image.i
      Protected R.RECT
      
      Window = WindowID(Window)
      GetWindowRect_(Window, @R)
      
      If R\left < 0
        R\right + R\left
        R\left = 0
      EndIf
      If R\top < 0
        R\bottom + R\top
        R\top = 0
      EndIf
      
      Image = CreateImage(#PB_Any, R\right - R\left, R\bottom - R\top)
      
      DC = StartDrawing(ImageOutput(Image)) 
        DesktopDC = GetDC_(GetDesktopWindow_())
        BitBlt_(DC, 0, 0, R\right - R\left, R\bottom - R\top, DesktopDC, R\left, R\top, #SRCCOPY)
        ReleaseDC_(GetDesktopWindow_(), DesktopDC)
      StopDrawing()
      
      SaveImage(Image, ImagePath)
      FreeImage(Image)
    EndProcedure
CompilerEndSelect



CompilerEndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 16
; Folding = -
; EnableXP